/*
 *   Copyright (C) 2015 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#if !defined(DMRRX_H)
#define  DMRRX_H

#include "Config.h"

#include <Arduino.h>

#include "DMRDefines.h"

#define  ARM_MATH_CM3
#include <arm_math.h>

enum DMR_STATE {
  DMR_NONE,
  DMR_SLOT1,
  DMR_SLOT2
};

class CDMRRX {
public:
  CDMRRX();

  void samples(const q15_t* samples, const uint8_t* control, uint8_t length);

private:
  uint32_t     m_pll[2U];
  bool         m_prev[2U];
  uint64_t     m_patternBuffer;
  uint8_t      m_buffer[50U];
  unsigned int m_dataPtr;
  unsigned int m_endPtr[2U];
  unsigned int m_index;
  uint8_t      m_control;
  DMR_STATE    m_state;
  unsigned int m_dataBits[2U];

  void    processBit(bool b);
  uint8_t countBits(uint64_t pattern) const;
};

#endif

